// After Effects Script with UI to Change Font
// Define the UI
var myWindow = new Window("palette", "Change Font Script", undefined);
myWindow.orientation = "column";

var fontDropdown = myWindow.add("dropdownlist", undefined, ["Sparkasse Rg", "Sparkasse Rg/regular/Type1", "Sparkasse Rg/regular"]); // Replace with your fonts
fontDropdown.selection = 0;

var goButton = myWindow.add("button", undefined, "Go");
var closeButton = myWindow.add("button", undefined, "Close");

myWindow.center();
myWindow.show();

// Function to change the font of all text layers in a comp
function changeFontsInComp(comp, selectedFont) {
    for (var i = 1; i <= comp.numLayers; i++) {
        var layer = comp.layer(i);
        if (layer instanceof TextLayer) {
            var textProp = layer.property("Source Text");
            var textDocument = textProp.value;
            textDocument.font = selectedFont;
            textProp.setValue(textDocument);
        }
    }
}

// Add functionality to Go button
goButton.onClick = function() {
    var selectedFont = fontDropdown.selection.text;
    if (app.project) {
        app.beginUndoGroup("Change All Fonts");
        for (var j = 1; j <= app.project.numItems; j++) {
            var item = app.project.item(j);
            if (item instanceof CompItem) {
                changeFontsInComp(item, selectedFont);
            }
        }
        app.endUndoGroup();
        alert("TaDA! Die Schriften wurden geändert.");
    } else {
        alert("No project found.");
    }
}

// Add functionality to Close button
closeButton.onClick = function() {
    myWindow.close();
}
